library angular2.src.change_detection.parser.locals;

import 'package:angular2/src/facade/lang.dart' show isPresent, BaseException;
import 'package:angular2/src/facade/collection.dart'
    show ListWrapper, MapWrapper;

class Locals {
  Locals parent;
  Map current;
  Locals(Locals parent, Map current) {
    this.parent = parent;
    this.current = current;
  }
  bool contains(String name) {
    if (MapWrapper.contains(this.current, name)) {
      return true;
    }
    if (isPresent(this.parent)) {
      return this.parent.contains(name);
    }
    return false;
  }
  get(String name) {
    if (MapWrapper.contains(this.current, name)) {
      return MapWrapper.get(this.current, name);
    }
    if (isPresent(this.parent)) {
      return this.parent.get(name);
    }
    throw new BaseException('''Cannot find \'${name}\'''');
  }
  set(String name, value) {
    if (MapWrapper.contains(this.current, name)) {
      MapWrapper.set(this.current, name, value);
    } else {
      throw new BaseException(
          'Setting of new keys post-construction is not supported.');
    }
  }
  clearValues() {
    MapWrapper.clearValues(this.current);
  }
}
