library angular2.src.change_detection.pipes.null_pipe;

import 'package:angular2/src/facade/lang.dart' show isBlank;
import './pipe.dart' show Pipe, NO_CHANGE;

class NullPipeFactory {
  bool supports(obj) {
    return NullPipe.supportsObj(obj);
  }
  Pipe create() {
    return new NullPipe();
  }
}
class NullPipe extends Pipe {
  bool called;
  NullPipe() : super() {
    this.called = false;
  }
  static bool supportsObj(obj) {
    return isBlank(obj);
  }
  supports(obj) {
    return NullPipe.supportsObj(obj);
  }
  transform(value) {
    if (!this.called) {
      this.called = true;
      return null;
    } else {
      return NO_CHANGE;
    }
  }
}
