library angular2.src.change_detection.pipes.pipe_registry;

import 'package:angular2/src/facade/collection.dart' show List, ListWrapper;
import 'package:angular2/src/facade/lang.dart'
    show isBlank, isPresent, BaseException, CONST;
import './pipe.dart' show Pipe;

class PipeRegistry {
  var config;
  PipeRegistry(config) {
    this.config = config;
  }
  Pipe get(String type, obj) {
    var listOfConfigs = this.config[type];
    if (isBlank(listOfConfigs)) {
      throw new BaseException(
          '''Cannot find a pipe for type \'${type}\' object \'${obj}\'''');
    }
    var matchingConfig = ListWrapper.find(listOfConfigs, (pipeConfig) {
      return pipeConfig.supports(obj);
    });
    if (isBlank(matchingConfig)) {
      throw new BaseException(
          '''Cannot find a pipe for type \'${type}\' object \'${obj}\'''');
    }
    return matchingConfig.create();
  }
}
