library angular2.src.core.annotations.annotations;

import 'package:angular2/src/facade/lang.dart'
    show ABSTRACT, CONST, normalizeBlank, isPresent;
import 'package:angular2/src/facade/collection.dart' show ListWrapper, List;
import 'package:angular2/di.dart' show Injectable;

@ABSTRACT()
class Directive extends Injectable {
  final String selector;
  final dynamic bind;
  final dynamic events;
  final List lifecycle;
  @CONST()
  const Directive({selector, bind, events, lifecycle})
      : selector = selector,
        bind = bind,
        events = events,
        lifecycle = lifecycle,
        super();
  bool hasLifecycleHook(String hook) {
    return isPresent(this.lifecycle)
        ? ListWrapper.contains(this.lifecycle, hook)
        : false;
  }
}
class Component extends Directive {
  final List services;
  @CONST()
  const Component({selector, bind, events, services, lifecycle})
      : services = services,
        super(
            selector: selector,
            bind: bind,
            events: events,
            lifecycle: lifecycle);
}
class DynamicComponent extends Directive {
  final dynamic services;
  @CONST()
  const DynamicComponent({selector, bind, events, services, lifecycle})
      : services = services,
        super(
            selector: selector,
            bind: bind,
            events: events,
            lifecycle: lifecycle);
}
class Decorator extends Directive {
  final bool compileChildren;
  @CONST()
  const Decorator({selector, bind, events, lifecycle, compileChildren: true})
      : compileChildren = compileChildren,
        super(
            selector: selector,
            bind: bind,
            events: events,
            lifecycle: lifecycle);
}
class Viewport extends Directive {
  @CONST()
  const Viewport({selector, bind, events, lifecycle}) : super(
          selector: selector, bind: bind, events: events, lifecycle: lifecycle);
}
const onDestroy = "onDestroy";
const onChange = "onChange";
