library angular2.src.core.compiler.binding_propagation_config;

import 'package:angular2/change_detection.dart'
    show ChangeDetector, CHECK_ONCE, DETACHED, CHECK_ALWAYS;

class BindingPropagationConfig {
  ChangeDetector _cd;
  BindingPropagationConfig(ChangeDetector cd) {
    this._cd = cd;
  }
  shouldBePropagated() {
    this._cd.mode = CHECK_ONCE;
  }
  shouldBePropagatedFromRoot() {
    this._cd.markPathToRootAsCheckOnce();
  }
  shouldNotPropagate() {
    this._cd.mode = DETACHED;
  }
  shouldAlwaysPropagate() {
    this._cd.mode = CHECK_ALWAYS;
  }
}
