library angular2.src.core.compiler.element_binder;

import 'package:angular2/src/facade/lang.dart' show int, isBlank, BaseException;
import './element_injector.dart' as eiModule;
import './directive_metadata.dart' show DirectiveMetadata;
import 'package:angular2/src/facade/collection.dart' show List, Map;
import './view.dart' as viewModule;

class ElementBinder {
  eiModule.ProtoElementInjector protoElementInjector;
  DirectiveMetadata componentDirective;
  DirectiveMetadata viewportDirective;
  List<int> textNodeIndices;
  bool hasElementPropertyBindings;
  viewModule.ProtoView nestedProtoView;
  Map events;
  String contentTagSelector;
  ElementBinder parent;
  int index;
  int distanceToParent;
  ElementBinder(int index, ElementBinder parent, int distanceToParent,
      eiModule.ProtoElementInjector protoElementInjector,
      DirectiveMetadata componentDirective,
      DirectiveMetadata viewportDirective) {
    if (isBlank(index)) {
      throw new BaseException('null index not allowed.');
    }
    this.protoElementInjector = protoElementInjector;
    this.componentDirective = componentDirective;
    this.viewportDirective = viewportDirective;
    this.parent = parent;
    this.index = index;
    this.distanceToParent = distanceToParent;
    this.events = null;
    this.textNodeIndices = null;
    this.hasElementPropertyBindings = false;
    this.nestedProtoView = null;
    this.contentTagSelector = null;
  }
}
