library angular2.src.core.compiler.pipeline.compile_control;

import 'package:angular2/src/facade/lang.dart' show isBlank;
import 'package:angular2/src/facade/collection.dart' show List, ListWrapper;
import './compile_element.dart' show CompileElement;
import './compile_step.dart' show CompileStep;

class CompileControl {
  List<CompileStep> _steps;
  num _currentStepIndex;
  CompileElement _parent;
  var _results;
  var _additionalChildren;
  CompileControl(steps) {
    this._steps = steps;
    this._currentStepIndex = 0;
    this._parent = null;
    this._results = null;
    this._additionalChildren = null;
  }
  internalProcess(
      results, startStepIndex, CompileElement parent, CompileElement current) {
    this._results = results;
    var previousStepIndex = this._currentStepIndex;
    var previousParent = this._parent;
    for (var i = startStepIndex; i < this._steps.length; i++) {
      var step = this._steps[i];
      this._parent = parent;
      this._currentStepIndex = i;
      step.process(parent, current, this);
      parent = this._parent;
    }
    ListWrapper.push(results, current);
    this._currentStepIndex = previousStepIndex;
    this._parent = previousParent;
    var localAdditionalChildren = this._additionalChildren;
    this._additionalChildren = null;
    return localAdditionalChildren;
  }
  addParent(CompileElement newElement) {
    this.internalProcess(
        this._results, this._currentStepIndex + 1, this._parent, newElement);
    this._parent = newElement;
  }
  addChild(CompileElement element) {
    if (isBlank(this._additionalChildren)) {
      this._additionalChildren = ListWrapper.create();
    }
    ListWrapper.push(this._additionalChildren, element);
  }
}
