library angular2.src.core.compiler.pipeline.element_binding_marker;

import 'package:angular2/src/facade/lang.dart' show isPresent;
import 'package:angular2/src/facade/collection.dart' show MapWrapper;
import 'package:angular2/src/dom/dom_adapter.dart' show DOM;
import './compile_step.dart' show CompileStep;
import './compile_element.dart' show CompileElement;
import './compile_control.dart' show CompileControl;

const NG_BINDING_CLASS = 'ng-binding';
class ElementBindingMarker extends CompileStep {
  process(
      CompileElement parent, CompileElement current, CompileControl control) {
    if (current.ignoreBindings) {
      return;
    }
    var hasBindings = (isPresent(current.textNodeBindings) &&
            MapWrapper.size(current.textNodeBindings) > 0) ||
        (isPresent(current.propertyBindings) &&
            MapWrapper.size(current.propertyBindings) > 0) ||
        (isPresent(current.variableBindings) &&
            MapWrapper.size(current.variableBindings) > 0) ||
        (isPresent(current.eventBindings) &&
            MapWrapper.size(current.eventBindings) > 0) ||
        (isPresent(current.decoratorDirectives) &&
            current.decoratorDirectives.length > 0) ||
        isPresent(current.viewportDirective) ||
        isPresent(current.componentDirective) ||
        isPresent(current.contentTagSelector);
    if (hasBindings) {
      var element = current.element;
      DOM.addClass(element, NG_BINDING_CLASS);
      current.hasBindings = true;
    }
  }
}
