library angular2.src.core.compiler.pipeline.text_interpolation_parser;

import 'package:angular2/src/facade/lang.dart'
    show RegExpWrapper, StringWrapper, isPresent;
import 'package:angular2/src/dom/dom_adapter.dart' show DOM;
import 'package:angular2/change_detection.dart' show Parser;
import './compile_step.dart' show CompileStep;
import './compile_element.dart' show CompileElement;
import './compile_control.dart' show CompileControl;

class TextInterpolationParser extends CompileStep {
  Parser _parser;
  TextInterpolationParser(Parser parser) : super() {
    this._parser = parser;
  }
  process(
      CompileElement parent, CompileElement current, CompileControl control) {
    if (!current.compileChildren || current.ignoreBindings) {
      return;
    }
    var element = current.element;
    var childNodes = DOM.childNodes(DOM.templateAwareRoot(element));
    for (var i = 0; i < childNodes.length; i++) {
      var node = childNodes[i];
      if (DOM.isTextNode(node)) {
        this._parseTextNode(current, node, i);
      }
    }
  }
  _parseTextNode(pipelineElement, node, nodeIndex) {
    var ast = this._parser.parseInterpolation(
        DOM.nodeValue(node), pipelineElement.elementDescription);
    if (isPresent(ast)) {
      DOM.setText(node, ' ');
      pipelineElement.addTextNodeBinding(nodeIndex, ast);
    }
  }
}
