library angular2.src.core.compiler.private_component_loader;

import './compiler.dart' show Compiler;
import './shadow_dom_strategy.dart' show ShadowDomStrategy;
import 'package:angular2/src/core/events/event_manager.dart' show EventManager;
import 'package:angular2/src/core/compiler/directive_metadata_reader.dart'
    show DirectiveMetadataReader;
import './private_component_location.dart' show PrivateComponentLocation;
import 'package:angular2/src/facade/lang.dart' show Type;

class PrivateComponentLoader {
  Compiler compiler;
  ShadowDomStrategy shadowDomStrategy;
  EventManager eventManager;
  DirectiveMetadataReader directiveMetadataReader;
  PrivateComponentLoader(Compiler compiler, ShadowDomStrategy shadowDomStrategy,
      EventManager eventManager,
      DirectiveMetadataReader directiveMetadataReader) {
    this.compiler = compiler;
    this.shadowDomStrategy = shadowDomStrategy;
    this.eventManager = eventManager;
    this.directiveMetadataReader = directiveMetadataReader;
  }
  load(Type type, PrivateComponentLocation location) {
    var annotation = this.directiveMetadataReader.read(type).annotation;
    return this.compiler.compile(type).then((componentProtoView) {
      location.createComponent(type, annotation, componentProtoView,
          this.eventManager, this.shadowDomStrategy);
    });
  }
}
