library angular2.src.core.compiler.private_component_location;

import 'package:angular2/src/core/annotations/annotations.dart' show Directive;
import 'package:angular2/src/core/dom/element.dart' show NgElement;
import './view.dart' as viewModule;
import './element_injector.dart' as eiModule;
import './shadow_dom_strategy.dart' show ShadowDomStrategy;
import 'package:angular2/src/core/events/event_manager.dart' show EventManager;
import 'package:angular2/src/facade/collection.dart' show ListWrapper;
import 'package:angular2/src/facade/lang.dart' show Type;

class PrivateComponentLocation {
  eiModule.ElementInjector _elementInjector;
  NgElement _elt;
  viewModule.View _view;
  PrivateComponentLocation(eiModule.ElementInjector elementInjector,
      NgElement elt, viewModule.View view) {
    this._elementInjector = elementInjector;
    this._elt = elt;
    this._view = view;
  }
  createComponent(Type type, Directive annotation,
      viewModule.ProtoView componentProtoView, EventManager eventManager,
      ShadowDomStrategy shadowDomStrategy) {
    var context =
        this._elementInjector.createPrivateComponent(type, annotation);
    var view =
        componentProtoView.instantiate(this._elementInjector, eventManager);
    view.hydrate(this._elementInjector.getShadowDomAppInjector(),
        this._elementInjector, null, context, null);
    shadowDomStrategy.attachTemplate(this._elt.domElement, view);
    ListWrapper.push(this._view.componentChildViews, view);
    this._view.changeDetector.addChild(view.changeDetector);
  }
}
