library angular2.src.core.compiler.shadow_dom_emulation.content_tag;

import './light_dom.dart' as ldModule;
import 'package:angular2/di.dart' show Inject, Injectable;
import 'package:angular2/src/dom/dom_adapter.dart' show DOM;
import 'package:angular2/src/facade/lang.dart' show isPresent;
import 'package:angular2/src/facade/collection.dart' show List, ListWrapper;

class ContentStrategy {
  List nodes;
  insert(List nodes) {}
}
@Injectable()
class RenderedContent extends ContentStrategy {
  var beginScript;
  var endScript;
  RenderedContent(contentEl) : super() {
    this.beginScript = contentEl;
    this.endScript = DOM.nextSibling(this.beginScript);
    this.nodes = [];
  }
  insert(List nodes) {
    this.nodes = nodes;
    DOM.insertAllBefore(this.endScript, nodes);
    this._removeNodesUntil(
        ListWrapper.isEmpty(nodes) ? this.endScript : nodes[0]);
  }
  _removeNodesUntil(node) {
    var p = DOM.parentElement(this.beginScript);
    for (var next = DOM.nextSibling(this.beginScript);
        !identical(next, node);
        next = DOM.nextSibling(this.beginScript)) {
      DOM.removeChild(p, next);
    }
  }
}
class IntermediateContent extends ContentStrategy {
  ldModule.LightDom destinationLightDom;
  IntermediateContent(ldModule.LightDom destinationLightDom) : super() {
    this.destinationLightDom = destinationLightDom;
    this.nodes = [];
  }
  insert(List nodes) {
    this.nodes = nodes;
    this.destinationLightDom.redistribute();
  }
}
class Content {
  String select;
  ContentStrategy _strategy;
  var contentStartElement;
  Content(
      ldModule.LightDom destinationLightDom, contentStartEl, String selector) {
    this.select = selector;
    this.contentStartElement = contentStartEl;
    this._strategy = isPresent(destinationLightDom)
        ? new IntermediateContent(destinationLightDom)
        : new RenderedContent(contentStartEl);
  }
  List nodes() {
    return this._strategy.nodes;
  }
  insert(List nodes) {
    this._strategy.insert(nodes);
  }
}
