library angular2.src.di.key;

import './exceptions.dart' show KeyMetadataError;
import 'package:angular2/src/facade/collection.dart' show MapWrapper, Map;
import 'package:angular2/src/facade/lang.dart' show int, isPresent;

class Key {
  var token;
  int id;
  dynamic metadata;
  Key(token, int id) {
    this.token = token;
    this.id = id;
    this.metadata = null;
  }
  static Key setMetadata(Key key, metadata) {
    if (isPresent(key.metadata) && !identical(key.metadata, metadata)) {
      throw new KeyMetadataError();
    }
    key.metadata = metadata;
    return key;
  }
  static Key get(token) {
    return _globalKeyRegistry.get(token);
  }
  static int get numberOfKeys {
    return _globalKeyRegistry.numberOfKeys;
  }
}
class KeyRegistry {
  Map _allKeys;
  KeyRegistry() {
    this._allKeys = MapWrapper.create();
  }
  Key get(token) {
    if (token is Key) return token;
    if (MapWrapper.contains(this._allKeys, token)) {
      return MapWrapper.get(this._allKeys, token);
    }
    var newKey = new Key(token, Key.numberOfKeys);
    MapWrapper.set(this._allKeys, token, newKey);
    return newKey;
  }
  int get numberOfKeys {
    return MapWrapper.size(this._allKeys);
  }
}
var _globalKeyRegistry = new KeyRegistry();
