library angular2.src.directives.if_dart;

import 'package:angular2/src/core/annotations/annotations.dart' show Viewport;
import 'package:angular2/src/core/compiler/view_container.dart'
    show ViewContainer;
import 'package:angular2/src/facade/lang.dart' show isBlank;

@Viewport(selector: '[if]', bind: const {'condition': 'if'})
class If {
  ViewContainer viewContainer;
  bool prevCondition;
  If(ViewContainer viewContainer) {
    this.viewContainer = viewContainer;
    this.prevCondition = null;
  }
  set condition(newCondition) {
    if (newCondition && (isBlank(this.prevCondition) || !this.prevCondition)) {
      this.prevCondition = true;
      this.viewContainer.create();
    } else if (!newCondition &&
        (isBlank(this.prevCondition) || this.prevCondition)) {
      this.prevCondition = false;
      this.viewContainer.clear();
    }
  }
}
