library angular2.test.test_lib.test_lib_spec;

import 'package:angular2/test_lib.dart'
    show
        describe,
        it,
        iit,
        ddescribe,
        expect,
        tick,
        async,
        SpyObject,
        beforeEach,
        proxy;
import 'package:angular2/src/facade/collection.dart' show MapWrapper;
import 'package:angular2/src/facade/lang.dart' show IMPLEMENTS;

class TestObj {
  var prop;
  TestObj(prop) {
    this.prop = prop;
  }
}
@proxy
class SpyTestObj extends SpyObject implements TestObj {
  noSuchMethod(m) {
    return super.noSuchMethod(m);
  }
}
main() {
  describe('test_lib', () {
    describe('equality', () {
      it('should structurally compare objects', () {
        var expected = new TestObj(new TestObj({'one': [1, 2]}));
        var actual = new TestObj(new TestObj({'one': [1, 2]}));
        var falseActual = new TestObj(new TestObj({'one': [1, 3]}));
        expect(actual).toEqual(expected);
        expect(falseActual).not.toEqual(expected);
      });
    });
    describe('toEqual for Maps', () {
      it('should detect equality for same reference', () {
        var m1 = MapWrapper.createFromStringMap({'a': 1});
        expect(m1).toEqual(m1);
      });
      it('should detect equality for same content', () {
        expect(MapWrapper.createFromStringMap({'a': 1}))
            .toEqual(MapWrapper.createFromStringMap({'a': 1}));
      });
      it('should detect missing entries', () {
        expect(MapWrapper.createFromStringMap({'a': 1})).not
            .toEqual(MapWrapper.createFromStringMap({}));
      });
      it('should detect different values', () {
        expect(MapWrapper.createFromStringMap({'a': 1})).not
            .toEqual(MapWrapper.createFromStringMap({'a': 2}));
      });
      it('should detect additional entries', () {
        expect(MapWrapper.createFromStringMap({'a': 1})).not
            .toEqual(MapWrapper.createFromStringMap({'a': 1, 'b': 1}));
      });
    });
    describe("spy objects", () {
      var spyObj;
      beforeEach(() {
        spyObj = new SpyTestObj();
      });
      it("should pass the runtime check", () {
        TestObj t = spyObj;
        expect(t).toBeDefined();
      });
      it("should return a new spy func with no calls", () {
        expect(spyObj.spy("someFunc")).not.toHaveBeenCalled();
      });
      it("should record function calls", () {
        spyObj.spy("someFunc").andCallFake((a, b) {
          return a + b;
        });
        expect(spyObj.someFunc(1, 2)).toEqual(3);
        expect(spyObj.spy("someFunc")).toHaveBeenCalledWith(1, 2);
      });
    });
  });
}
